# common functions used between devel scripts
# maybe other stuff too

package Devel;

use strict;
use FileHandle;
use Exporter;

use vars qw(@ISA @EXPORT);

@ISA = qw(Exporter);
@EXPORT = qw(make_cmd cvs_cmd check_out_modules);

 
sub make_cmd
{
  unlink("/tmp/make.log");
  system("make @_ &> /tmp/make.log");
  my $r = $?;

  if($r & 128){  #stupid random core dumps.  retry once if we get one of those.
    system("make @_ &> /tmp/make.log");
    $r = $?;
  }

  if ($r) {
    my $fh = new FileHandle("</tmp/make.log");
    if (defined($fh)) {
      print STDOUT <$fh>;
      $fh->close();
    }
    print STDERR "\nERROR: make @_ failed.\n";
  }
  return ($r == 0);
}
  
sub cvs_cmd
{
  unlink("/tmp/cvs.log");
  system ("cvs @_ &> /tmp/cvs.log");
  my $r = $?;
  if ($r) {
    my $fh = new FileHandle("</tmp/cvs.log");
    if (defined($fh)) {
      print STDOUT <$fh>;
      $fh->close();
    }
    print STDERR "ERROR: cvs @_ failed.\n";
  }
  return ($r == 0);
}

sub check_out_modules
{
    my ($packlist_file, $deftag, $module_list, $quiet) = @_;
    if (!-e $packlist_file) { return 0; }

    my $fh = new FileHandle("< $packlist_file") || die;
    while (defined($_ = <$fh>)) 
    {
        if (m/^module: ([^:]+)(?::([^:]+)(?::(\S*))?)?/i) 
        {
            my $module = $1;
            my $tag = $2 || $deftag;
            my $buildSections = $3 || "makefile";
            chomp($module, $tag, $buildSections);
      
            # don't bother updating modules already in module_list
            next if $$module_list{$module};

            if (-d $module) 
            {
	            system("cvs update -PAd " . ($tag ? "-r $tag" : '') . " $module &> $module.co");
            } 
            else 
            {
    	        system("cvs co -PA " . ($tag ? "-r $tag" : '') . " $module &> $module.co");
            }
            if ($?) 
            { 
                print STDERR "FAILED: cvs co -r $tag $module\n"; 
		return 0;
            }
            else 
            { 
	      check_out_modules("${module}/packing_list", $tag, $module_list, $quiet) 
		|| check_out_modules("${module}/templates/packing_list.tmpl", $tag, $module_list, $quiet);
	      $quiet ||  print STDERR "ok: $module\n"; 
	      $$module_list{$module} = $buildSections; 
            }
        }
    }
  
    return 1;
}

1;
